<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SESim: SESim introduction</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SESim
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',false,false,'search.php','Search');
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">SESim introduction </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h1><a class="anchor" id="intro"></a>
Introduction</h1>
<p>The <b>SESim</b> software allows to simulate and evaluate force control algorithms. The software implementation is divided in two distinct parts:</p><ul>
<li><a class="el" href="class_simulation.html" title="Class used to do simulations. ">Simulation</a></li>
<li>Performance Indicators (PIs) evaluation</li>
</ul>
<p>Each part is designed to work standalone. The main reason for this division is that the evaluation of the PIs must be available for both real and virtual experiments.</p>
<h1><a class="anchor" id="simulation"></a>
Simulation</h1>
<p>The simulation software is written in Matlab and uses also Simulink to execute the system. This software allows the user to execute multiple simulations of the system of interest considering the necessary reference signals needed to calculate the PIs. The user can chose an actuator model among already implemented models and can implement his own controller, or chose among already implemented ones. Finally the user need to set some simulation parameters. The software performs the simulations for all the given environments, chosen by the user, ans saves the results in specified <em>.csv</em> files. These files contain all the data for the PIs evaluation.</p>
<p>The simulation parameters required by the user are stored in a .yaml file. Here an example with an explanation of the main parameters: </p><div class="fragment"><div class="line">conf1: # the configuration</div><div class="line">  h_control: 0.001 # period of the control loop</div><div class="line">  h_physics: 0.001 # period of the simulation</div><div class="line">  config_name: conf1 # name of the configuration</div><div class="line">  simulation_output_dir: simulation_outputs_3/ # simulation output directory</div><div class="line">  motor: # motor parameters</div><div class="line">    motor_type: Current # name of the motor model to use</div><div class="line">    jm: 0.02 # parameter of Current</div><div class="line">    dm: 0.01 # parameter of Current</div><div class="line">    k_spring: 12.34 # parameter of Current</div><div class="line">    current_saturation: 10.0 # current saturation</div><div class="line">  motor_controller: # motor controller parameters</div><div class="line">    name: PID_Controller # name of the motor controller to use</div><div class="line">    kp: 10 # parameter of PID_Controller</div><div class="line">    ki: 0 # parameter of PID_Controller</div><div class="line">    kd: 0 # parameter of PID_Controller</div><div class="line">  transparency: # transparency parameters</div><div class="line">    enable_transparency: true # enable or desable the transparency simulation</div><div class="line">    environment: # environment parameters</div><div class="line">      k_des: 0 # desired environment stiffness</div><div class="line">      b_des: 0 # desired environment damping</div><div class="line">      j_des: 0 # desired environment inertia</div><div class="line">    reference_signal: # reference signal for the transparency experiments</div><div class="line">      sweep_max_freq: 10 # final frequency of the sweep</div><div class="line">      sweep_amplitude: 0.001 # amplitude of the sweep</div><div class="line">      sweep_duration: 50 # duration of the sweep</div><div class="line">  tracking: # tracking parameters</div><div class="line">    environment: # environment parameters</div><div class="line">      index_ke: 2.0</div><div class="line">      index_je: 2.0</div><div class="line">      damping_factor: 1.0 # damping factor, used to generate d_e</div><div class="line">      k_e_vect: [0.01, 0.02] # vector of stiffnesses</div><div class="line">      j_e_vect: [0.001, 0.002] # vector of inertias</div><div class="line">      KES_NUM_ELEM: 2.0</div><div class="line">      JES_NUM_ELEM: 2.0</div><div class="line">    reference_signal: # reference signal for the tracking experiments</div><div class="line">      amplitude_step_1: 0.5 # amplitude of the first step</div><div class="line">      amplitude_step_2: 1.0 # amplitude of the second step</div><div class="line">      amplitude_step_3: 1.5 # amplitude of the third step</div><div class="line">      amplitude_step_4: 1.0 # amplitude of the fourth step and offset the sweep</div><div class="line">      step_duration: 10 # duration of each step</div><div class="line">      sweep_amplitude: 0.4 # final frequency of the sweep</div><div class="line">      sweep_duration: 10.0 # amplitude of the sweep</div><div class="line">      sweep_max_freq: 5.0 # duration of the sweep</div><div class="line">  loop:</div><div class="line">    frequency: 1000 # frequency of the control loop (it must be 1/h_control)</div></div><!-- fragment --><p>Implemented models:</p><ul>
<li>SEA current motor</li>
<li>(not yet) SEA voltage motor</li>
</ul>
<p>Available implemented controllers:</p><ul>
<li>PID controller</li>
<li>PID controller with AF</li>
</ul>
<p>We will show the <b>SEA current motor model</b> and the <b>PID controller</b> more in depth later.</p>
<h2><a class="anchor" id="files_composition"></a>
Files composition</h2>
<p>Although there exist two distinct softwares for simulation and evaluation, they share some files and directories.</p>
<p>Files hierarchy is as follow:</p><ul>
<li><b><a class="el" href="_simulation_8m.html">Simulation.m</a></b>: class used to do a simulation</li>
<li><b>Simulation/sim_model.mdl</b>: simulink model used in the simulation</li>
<li><b>Parameters.m</b>: class used to store some parameters used in the simulations</li>
<li><b><a class="el" href="main_forecast_p_i_8m.html">mainForecastPI.m</a></b>: file to run to calculate PIs on given data (explained in the next section)</li>
<li><b><a class="el" href="main_forecast_simulations_8m.html">mainForecastSimulations.m</a></b>: file to run multiple simulations</li>
<li><b><a class="el" href="configuration_8m.html" title="Configuration file. ">configuration.m</a></b>: file that loads the parameters from the .yaml file</li>
<li><b>Utils/</b>: directory that contains some utility functions</li>
<li><b>TaskLoader/task_loader.m</b>: function that loads in the workspace some predefined signals</li>
<li><b>Simulation/Models/</b>: directory with all the implemented system models</li>
<li><b>PerformanceIndicators/</b>: files present here will be explained in the next section</li>
<li><b>Controller/</b>: directory that contains all the implemented system controllers</li>
</ul>
<h2><a class="anchor" id="configuration"></a>
Configuration</h2>
<p>In the <a class="el" href="configuration_8m.html" title="Configuration file. ">configuration.m</a> file is set the model and the controller of the transparency experiments. This should not be modified by the user.</p>
<h2><a class="anchor" id="task_loader"></a>
Task loader</h2>
<p>In the task_loader.m file, the user has access to some standard signal, i.e. <em>impulse(t), step(t) and ramp(t)</em>.</p>
<h2><a class="anchor" id="simulink_model"></a>
Simulink model</h2>
<div class="image">
<object type="image/svg+xml" data="sim_model.svg">sim_model.svg</object>
</div>
<p>The simulink model is simple, there are 3 blocks (from left to right):</p><ul>
<li>the first contains the <b>inputs</b>, i.e. the force reference</li>
<li>the second is an <b>S-Fun</b> block (explained in details below)</li>
<li>the third saves the simulation <b>outputs</b> to the Matlab workspace</li>
</ul>
<h2><a class="anchor" id="s_function"></a>
S-Function</h2>
<p>S-functions (system-functions) provide a powerful mechanism for extending the capabilities of the Simulink environment. An S-function is a computer language description of a Simulink block written in MATLAB or other languages such as C, C++, and Fortran. S-functions use a special calling syntax called the S-function API that enables you to interact with the Simulink engine. By following a set of simple rules, you can implement an algorithm in an S-function and use the S-Function block to add it to a Simulink model. S-functions define how a block works during different parts of simulation, such as initialization, update, derivatives, outputs and termination. In every step of a simulation, a method is invoked by the simulation engine to fulfill a specific task.</p>
<h3><a class="anchor" id="how_it_works"></a>
How it works</h3>
<p>Execution of a Simulink model proceeds in stages.</p><ul>
<li><b>Initialization phase</b> where the Simulink engine incorporates library blocks into the model, propagates signal widths, data types, and sample times, evaluates block parameters, determines block execution order, and allocates memory.</li>
<li><b><a class="el" href="class_simulation.html" title="Class used to do simulations. ">Simulation</a> phase</b>, where the engine enters in a simulation loop, where each pass through the loop is referred to as a simulation step. During each simulation step, the engine executes each block in the model and, for each block, the engine invokes functions that compute the block states, derivatives, and outputs for the current sample time. The entire simulation loop then continues until the simulation is complete.</li>
</ul>
<p>An S-function comprises a set of S-function callback methods that perform tasks required at each simulation stage. During simulation of a model, at each simulation stage, the Simulink engine calls the appropriate methods for each S-Function block in the model. Tasks performed by S-function callback methods include:</p><ul>
<li>Calculation of outputs: outputs are calculated.</li>
<li>Update discrete states: the block performs once-per-time-step activities such as updating discrete states.</li>
<li>Initialize and Terminate Methods: perform initialization and termination activities required by S-function only once, e.g. initializing state vectors or freeing memory.</li>
<li>Integration: the solvers can compute the integration of the variables.</li>
</ul>
<h3><a class="anchor" id="our_implementation_of_sfun"></a>
Our implementation of sfun.m</h3>
<div class="fragment"><div class="line">% Return the sizes, initial conditions, and sample times <span class="keywordflow">for</span> the S-<span class="keyword">function</span>.</div><div class="line">function [sys, x0, str, ts] = <a class="code" href="_doxygen_matlab_2code__snippets_2sfun_8m.html#a8e70eee6f52f81f3523b57b6808e2eff">mdlInitializeSizes</a></div><div class="line">    global simulation</div><div class="line">    model = simulation.model;</div><div class="line">    controller = simulation.controller;</div><div class="line">    controller.reset();</div><div class="line">    </div><div class="line">    sizes = simsizes;</div><div class="line"></div><div class="line">    sizes.NumContStates  = model.num_states;</div><div class="line">    sizes.NumDiscStates  = 0;</div><div class="line">    sizes.NumOutputs     = model.num_outputs;</div><div class="line">    sizes.NumInputs      = model.num_inputs;</div><div class="line">    sizes.DirFeedthrough = 0;</div><div class="line">    sizes.NumSampleTimes = 1;   % At least one sample <a class="code" href="_i_controller__prop_8m.html#a9a5dcf2fcad7bf3ac86d488d1b924363">time</a> is needed.</div><div class="line"></div><div class="line">    sys = simsizes(sizes);</div><div class="line"></div><div class="line">    % Initialise the initial conditions.</div><div class="line">    x0 = model.get_initial_state();</div><div class="line">    model.reset();</div><div class="line">    str = [];</div><div class="line">    ts = [0, 0];</div><div class="line"></div><div class="line">% Return the derivatives <span class="keywordflow">for</span> the continuous states.</div><div class="line">function sys = <a class="code" href="_doxygen_matlab_2code__snippets_2sfun_8m.html#a910732398e452f0762c88874ac95fa54">mdlDerivatives</a>(t, x, u)</div><div class="line">    global simulation</div><div class="line">    sys = simulation.model.fun_derivatives(t,x,u);</div><div class="line"></div><div class="line">% Handle discrete state updates, sample <a class="code" href="_i_controller__prop_8m.html#a9a5dcf2fcad7bf3ac86d488d1b924363">time</a> hits, and major <a class="code" href="_i_controller__prop_8m.html#a9a5dcf2fcad7bf3ac86d488d1b924363">time</a> step</div><div class="line">% requirements.</div><div class="line">function sys = <a class="code" href="_doxygen_matlab_2code__snippets_2sfun_8m.html#af5c48fa51a29163334e05344150dc71e">mdlUpdate</a>(t, x, u)</div><div class="line">    global simulation</div><div class="line">    sys = simulation.model.fun_update(t, x, u);</div><div class="line"></div><div class="line">% Return the block outputs.</div><div class="line">function sys = <a class="code" href="_doxygen_matlab_2code__snippets_2sfun_8m.html#ab8f1cecad96bd516078448d07082de25">mdlOutputs</a>(t, x, u)</div><div class="line">    global simulation</div><div class="line">    sys = simulation.model.fun_outputs(t, x, u);</div></div><!-- fragment --><p>As one can see from the code, sfun.m requires the wrapper of our object-oriented code which holds model, controller and parameters for the ongoing simulation. To exploit the advantages of S-Fun, we will see that models and controllers override the implementation of <em><a class="el" href="_current__met_8m.html#a6108ff447601d4c6a683b8f3c8e29ed5">fun_derivatives()</a>, <a class="el" href="_current__met_8m.html#a2ed784a2d550a43a37b4d32e62ad09d1">fun_update()</a> and <a class="el" href="_current__met_8m.html#a195100623fa9887b2e36539bc37c655e">fun_outputs()</a></em>.</p>
<h1><a class="anchor" id="software_architecture"></a>
Software architecture and class hierarchy</h1>
<div class="image">
<object type="image/svg+xml" data="overview_classes_scheme.svg">overview_classes_scheme.svg</object>
</div>
<h2><a class="anchor" id="parameters"></a>
Parameters</h2>
<p><a class="el" href="class_parameters.html" title="Class that handles the parameters for: simulation, motor, controller, reference signal and environmen...">Parameters</a> is a class with dynamic parameters (it inherits from <em>dynamicprops</em>) used to store the parameters for the simulation and evaluation. Standard parameters are the following:</p>
<div class="fragment"><div class="line">properties (GetAccess = <span class="keyword">public</span>, SetAccess = <span class="keyword">public</span>)</div><div class="line">    %&gt; simulation parameter - physics update period</div><div class="line">    <a class="code" href="_doxygen_matlab_2code__snippets_2_parameters_8m.html#a447a833e9e05c9edddfee30c624f2b06">h_physics</a></div><div class="line">    %&gt; simulation parameter - control update period</div><div class="line">    <a class="code" href="_doxygen_matlab_2code__snippets_2_parameters_8m.html#aee78dfd04bb1abd60c60c46334ce54de">h_control</a></div><div class="line"></div><div class="line">    %&gt; structure <span class="keywordflow">for</span> the <a class="code" href="_doxygen_matlab_2code__snippets_2_parameters_8m.html#a481937ec68310913213b38c22b89fcd2">motor</a> parameters</div><div class="line">    <a class="code" href="_doxygen_matlab_2code__snippets_2_parameters_8m.html#a481937ec68310913213b38c22b89fcd2">motor</a></div><div class="line">    %&gt; structure <span class="keywordflow">for</span> the <a class="code" href="_doxygen_matlab_2code__snippets_2_parameters_8m.html#a481937ec68310913213b38c22b89fcd2">motor</a> controller parameters</div><div class="line">    <a class="code" href="_doxygen_matlab_2code__snippets_2_parameters_8m.html#a4ac7237569c22cdae1763e84f2d5284b">motor_controller</a></div><div class="line"></div><div class="line">    %&gt; structure <span class="keywordflow">for</span> the <a class="code" href="_doxygen_matlab_2code__snippets_2_parameters_8m.html#a4801ead0cfada9df307f589e57c65cd8">transparency</a> parameters</div><div class="line">    <a class="code" href="_doxygen_matlab_2code__snippets_2_parameters_8m.html#a4801ead0cfada9df307f589e57c65cd8">transparency</a></div><div class="line">    %&gt; structure <span class="keywordflow">for</span> the <a class="code" href="_doxygen_matlab_2code__snippets_2_parameters_8m.html#a182f4909a999dec0479fac3b0b21f5db">tracking</a> parameters</div><div class="line">    <a class="code" href="_doxygen_matlab_2code__snippets_2_parameters_8m.html#a182f4909a999dec0479fac3b0b21f5db">tracking</a></div><div class="line">end</div><div class="line">properties (GetAccess = <span class="keyword">public</span>, SetAccess = <span class="keyword">private</span>)</div><div class="line">    %&gt; directory of the simulation output</div><div class="line">    <a class="code" href="_doxygen_matlab_2code__snippets_2_parameters_8m.html#af3799ba2c0a6560de0749efa0427052e">simulation_output_dir</a></div><div class="line"></div><div class="line">    %&gt; configuration <a class="code" href="_i_controller__prop_8m.html#a73d044705182dce0379a1c211dca6ec6">name</a></div><div class="line">    <a class="code" href="_doxygen_matlab_2code__snippets_2_parameters_8m.html#aabd89270bd3e995475bc1a02cf7b14d6">config_name</a></div><div class="line">end</div></div><!-- fragment --><p>Thanks to the dynamicprops, there can be other parameters added by the user. <br />
 <a class="el" href="class_parameters.html" title="Class that handles the parameters for: simulation, motor, controller, reference signal and environmen...">Parameters</a> has a method to save all the parameters in a <em>.yaml</em> file, and also a method to read all the parameters from a <em>.yaml</em> file.</p>
<h2><a class="anchor" id="simulation"></a>
Simulation</h2>
<div class="image">
<object type="image/svg+xml" data="simulation_class_diagram.svg">simulation_class_diagram.svg</object>
</div>
<p><a class="el" href="class_simulation.html" title="Class used to do simulations. ">Simulation</a> is a class that inherits from <em>handle</em>, which is an abstract class used to implement subclasses that inherit handle behavior. In this way more than one variable can refer to the same handle object because they actually holds a reference to the object. <a class="el" href="class_simulation.html" title="Class used to do simulations. ">Simulation</a> is a wrapper of our object-oriented code that contains the parameters, the model and the controller of the actual experiment.</p>
<h2><a class="anchor" id=""></a>
</h2>
<div class="image">
<object type="image/svg+xml" data="model_class_diagram.svg">model_class_diagram.svg</object>
</div>
<p><a class="el" href="class_i_model.html" title="Base class for all the models implementations. ">IModel</a> is a class that inherits from <em>handle</em>. All model implementations must have <a class="el" href="class_i_model.html" title="Base class for all the models implementations. ">IModel</a> as superclass.</p>
<h3><a class="anchor" id="imodel"></a>
IModel</h3>
<p>The properties are: </p><div class="fragment"><div class="line">properties</div><div class="line">    <a class="code" href="_i_model__prop_8m.html#a592dff204bc2adeafa81d1af5d8c09cc">type</a></div><div class="line">    <a class="code" href="_i_model__prop_8m.html#ac08e733eaa9bb7139d963f595fcc0a0e">num_states</a>      % number of states</div><div class="line">    <a class="code" href="_i_model__prop_8m.html#a6a2299a4bd1517f715b45feefc99510a">num_outputs</a>     % number of outputs</div><div class="line">    <a class="code" href="_i_model__prop_8m.html#a959b7a7a9b3913fe70bb9c1f1106ab75">num_inputs</a>      % number of inputs</div><div class="line">    <a class="code" href="_i_model__prop_8m.html#af313de75b0bca6f3b4248813591b0fe7">ref_index</a>       % index used in the <a class="code" href="_current__met_8m.html#a2ed784a2d550a43a37b4d32e62ad09d1">fun_update</a>()</div><div class="line">end</div></div><!-- fragment --><p> While the methods are: </p><div class="fragment"><div class="line">methods</div><div class="line">    <span class="keyword">function</span> x = <a class="code" href="_current__met_8m.html#a445f33d87e8aca91c27220cd4d8e16da">get_initial_state</a>(obj)</div><div class="line">        x = zeros(1, obj.num_states);</div><div class="line">    end</div><div class="line">    </div><div class="line">    <span class="keyword">function</span> sys = <a class="code" href="_current__met_8m.html#a6108ff447601d4c6a683b8f3c8e29ed5">fun_derivatives</a>(t, x, u)</div><div class="line">        assert(<span class="keyword">false</span>, <span class="stringliteral">&#39;IMPLEMENT THE DERIVATIVES FUNCTION!&#39;</span>);</div><div class="line">        sys = zeros(obj.num_states, 1);</div><div class="line">    end</div><div class="line">    </div><div class="line">    <span class="keyword">function</span> sys = <a class="code" href="_current__met_8m.html#a2ed784a2d550a43a37b4d32e62ad09d1">fun_update</a>(t, x, u)</div><div class="line">        assert(<span class="keyword">false</span>, <span class="stringliteral">&#39;IMPLEMENT THE UPDATE FUNCTION!&#39;</span>);</div><div class="line">        sys = [];</div><div class="line">    end</div><div class="line">    </div><div class="line">    <span class="keyword">function</span> sys = <a class="code" href="_current__met_8m.html#a195100623fa9887b2e36539bc37c655e">fun_outputs</a>(t, x, u)</div><div class="line">        assert(<span class="keyword">false</span>, <span class="stringliteral">&#39;IMPLEMENT THE OUTPUT FUNCTION!&#39;</span>);</div><div class="line">        sys = [];</div><div class="line">    end</div><div class="line">end</div></div><!-- fragment --><p> Asserts are present to help the user to override all the required <a class="el" href="class_i_model.html" title="Base class for all the models implementations. ">IModel</a> methods.</p>
<h3><a class="anchor" id="implemented_models"></a>
Implemented models</h3>
<p>Among implemented models we provide a <b>SEA with current controlled motor</b>. This model represents the equation of a SEA, seen in equation eqn:sea}, with a current motor as seen in the equation eqn:motor_model}, with spring stiffness <img class="formulaInl" alt="$K_s$" src="form_2.png"/>, motor damping <img class="formulaInl" alt="$d_m$" src="form_3.png"/> and motor inertia <img class="formulaInl" alt="$J_m$" src="form_4.png"/>, and in contact with a second order environment with inertia <img class="formulaInl" alt="$J_e$" src="form_1.png"/>, damping <img class="formulaInl" alt="$d_e$" src="form_5.png"/> and stiffness <img class="formulaInl" alt="$K_e$" src="form_0.png"/>. Clearly its superclass is <a class="el" href="class_i_model.html" title="Base class for all the models implementations. ">IModel</a>. It's important to know that it has 4 states, 4 outputs and 0 inputs. </p><div class="fragment"><div class="line"><span class="keyword">function</span> x = <a class="code" href="_current__met_8m.html#a445f33d87e8aca91c27220cd4d8e16da">get_initial_state</a>(obj)</div><div class="line">    x = [0, 0, 0, 0];</div><div class="line">end</div><div class="line"></div><div class="line"><span class="keyword">function</span> sys = <a class="code" href="_current__met_8m.html#a6108ff447601d4c6a683b8f3c8e29ed5">fun_derivatives</a>(obj, t, x, u)</div><div class="line">    global simulation</div><div class="line">    params = simulation.params;</div><div class="line">    </div><div class="line">    sys(1) = x(2);</div><div class="line">    sys(2) = (1 / params.Jm) * (obj.U - params.k_spring * (x(1) - x(3)) - params.dm * x(2));</div><div class="line">    sys(3) = x(4);</div><div class="line">    sys(4) = (1 / params.Je) * (- params.de * x(4) - params.ke * x(3) + params.k_spring * (x(1) - x(3)));</div><div class="line">end</div><div class="line"></div><div class="line"><span class="keyword">function</span> sys = <a class="code" href="_current__met_8m.html#a2ed784a2d550a43a37b4d32e62ad09d1">fun_update</a>(obj, t, x, u)</div><div class="line">    global simulation</div><div class="line">    params = simulation.params;</div><div class="line">    controller = simulation.controller;</div><div class="line">    sys = [];</div><div class="line">    </div><div class="line">    <a class="code" href="_i_controller__prop_8m.html#ae2b0415b572e4308dc810ad1306534af">ref</a> = simulation.ref(obj.ref_index);</div><div class="line">    obj.ref_index = obj.ref_index + 1;</div><div class="line">    obj.U = controller.process(t, x(1), x(2), x(3), x(4), <a class="code" href="_i_controller__prop_8m.html#ae2b0415b572e4308dc810ad1306534af">ref</a>);</div><div class="line">    obj.prev_update_t = t;</div><div class="line">end</div><div class="line"></div><div class="line"><span class="keyword">function</span> sys = <a class="code" href="_current__met_8m.html#a195100623fa9887b2e36539bc37c655e">fun_outputs</a>(obj, t, x, u)</div><div class="line">    sys = [x(1) x(2) x(3) x(4)];</div><div class="line">end</div><div class="line"></div><div class="line">% [...] other code</div></div><!-- fragment --><p> All the <em>params</em> are inside the Parameters.m file. From the code we see that the model calls the controller.</p>
<h2><a class="anchor" id="controllers"></a>
Controllers</h2>
<div class="image">
<object type="image/svg+xml" data="controller_class_diagram.svg">controller_class_diagram.svg</object>
</div>
<p><a class="el" href="class_i_controller.html" title="Base class for all the controllers implementations. ">IController</a> is a class that inherits from <em>handle</em>. All controllers implementations must have <a class="el" href="class_i_controller.html" title="Base class for all the controllers implementations. ">IController</a> as superclass.</p>
<h3><a class="anchor" id="icontroller"></a>
IController</h3>
<p>The properties are: </p><div class="fragment"><div class="line">properties (GetAccess = <span class="keyword">public</span>, SetAccess = <span class="keyword">private</span>)</div><div class="line">    <a class="code" href="_i_controller__prop_8m.html#a9a5dcf2fcad7bf3ac86d488d1b924363">time</a>    % <a class="code" href="_i_controller__prop_8m.html#a9a5dcf2fcad7bf3ac86d488d1b924363">time</a> signal</div><div class="line">    <a class="code" href="_i_controller__prop_8m.html#ae2b0415b572e4308dc810ad1306534af">ref</a>     % reference signal</div><div class="line">    <a class="code" href="_i_controller__prop_8m.html#a35c88496fe3060ff4b9c67b1c5f1ff0f">tau</a>     % force signal</div><div class="line"></div><div class="line">    <a class="code" href="_i_controller__prop_8m.html#a5072e5230b85a931dc13ab3e5e885154">prev_U</a>      % processed value in the previous step</div><div class="line">    <a class="code" href="_i_controller__prop_8m.html#a0c689c7a2b1d359f66e49e052a14d72b">prev_ref</a>    % reference value in the previous step</div><div class="line">    <a class="code" href="_i_controller__prop_8m.html#ae2ba270a4e88ddc59d27147482ca53ec">prev_t</a>      % <a class="code" href="_i_controller__prop_8m.html#a9a5dcf2fcad7bf3ac86d488d1b924363">time</a> value in the previous step</div><div class="line">end</div><div class="line">properties (GetAccess = public, SetAccess = protected)</div><div class="line">    <a class="code" href="_i_controller__prop_8m.html#a73d044705182dce0379a1c211dca6ec6">name</a>    % <a class="code" href="_i_controller__prop_8m.html#a73d044705182dce0379a1c211dca6ec6">name</a> of the controller</div><div class="line"></div><div class="line">    % General purpose debug signals</div><div class="line">    <a class="code" href="_i_controller__prop_8m.html#afaa1f8279f05b2c01704413b91ea23d8">debug1</a></div><div class="line">    <a class="code" href="_i_controller__prop_8m.html#adfc40a1e446bb64c4e9c4f6216641901">debug2</a></div><div class="line">    <a class="code" href="_i_controller__prop_8m.html#a02f4bee6bbeef8bd446032b0c685cb63">debug3</a></div><div class="line">end</div><div class="line">properties (Access = public)</div><div class="line">    % Variables used to manage the control loop frequency</div><div class="line">    <a class="code" href="_i_controller__prop_8m.html#a9593765ae9066406e2e4a852b31c2779">control_loop_max</a></div><div class="line">    <a class="code" href="_i_controller__prop_8m.html#a0b426d363873b67b372a2849b84fd168">control_loop_count</a></div><div class="line">end</div></div><!-- fragment --><p> While the main methods are: </p><div class="fragment"><div class="line"><span class="keyword">function</span> U = <a class="code" href="_i_controller__met_8m.html#ad9482202ed25388acd853771872cc5bd">process</a>(obj, t, theta_m, dtheta_m, theta_e, dtheta_e, <a class="code" href="_i_controller__prop_8m.html#ae2b0415b572e4308dc810ad1306534af">ref</a>)</div><div class="line">    % necessary to retrieve the index</div><div class="line">    global simulation</div><div class="line">    index = simulation.index;</div><div class="line"></div><div class="line">    U = obj.prev_U;</div><div class="line"></div><div class="line">    % enter in <span class="keyword">this</span> loop only with a frequency of 1/<a class="code" href="_doxygen_matlab_2code__snippets_2_parameters_8m.html#aee78dfd04bb1abd60c60c46334ce54de">h_control</a></div><div class="line">    obj.control_loop_count = obj.control_loop_count + 1;</div><div class="line">    <span class="keywordflow">if</span>(obj.control_loop_count &gt;= obj.control_loop_max)</div><div class="line">        obj.control_loop_count = 0;</div><div class="line"></div><div class="line">        % call the <a class="code" href="_i_controller__met_8m.html#ad9482202ed25388acd853771872cc5bd">process</a> of the child</div><div class="line">        U = obj.process_(t,tau_s,dtau_s,theta_m,dtheta_m,theta_e,dtheta_e,<a class="code" href="_i_controller__prop_8m.html#ae2b0415b572e4308dc810ad1306534af">ref</a>);</div><div class="line"></div><div class="line">        % update previous controller values</div><div class="line">        obj.prev_ref = <a class="code" href="_i_controller__prop_8m.html#ae2b0415b572e4308dc810ad1306534af">ref</a>;</div><div class="line">        obj.prev_t = t;</div><div class="line">        obj.prev_U = U;</div><div class="line">    <span class="keywordflow">else</span></div><div class="line">        % update arrays with previous values</div><div class="line">        obj.debug1(index) = obj.debug1(index-1);</div><div class="line">        obj.debug2(index) = obj.debug2(index-1);</div><div class="line">        obj.debug3(index) = obj.debug3(index-1);</div><div class="line">    end</div><div class="line"></div><div class="line">    % update arrays with <span class="keyword">new</span> values</div><div class="line">    obj.time(index) = t;</div><div class="line">    obj.ref(index) = <a class="code" href="_i_controller__prop_8m.html#ae2b0415b572e4308dc810ad1306534af">ref</a>;</div><div class="line">    obj.tau(index) = tau_s;</div><div class="line">end</div><div class="line"></div><div class="line"><span class="keyword">function</span> [U,<a class="code" href="_i_controller__prop_8m.html#a35c88496fe3060ff4b9c67b1c5f1ff0f">tau</a>] = <a class="code" href="_i_controller__met_8m.html#a770267f2268b177addbd6030f3131175">process_</a>(obj, t, theta_m, dtheta_m, theta_e, dtheta_e, <a class="code" href="_i_controller__prop_8m.html#ae2b0415b572e4308dc810ad1306534af">ref</a>)</div><div class="line">    assert(<span class="keyword">false</span>, <span class="stringliteral">&#39;IMPLEMENT THE CONTROLLER!&#39;</span>);</div><div class="line">    U = 0;</div><div class="line">    <a class="code" href="_i_controller__prop_8m.html#a35c88496fe3060ff4b9c67b1c5f1ff0f">tau</a> = 0;</div><div class="line">end</div></div><!-- fragment --><p> Assert is present to help the user to override all the <a class="el" href="class_i_controller.html" title="Base class for all the controllers implementations. ">IController</a> methods.</p>
<h3><a class="anchor" id="implemented_controllers"></a>
Implemented controllers</h3>
<p>There are already available:</p><ul>
<li><b>PID controller</b>, with settable proportional <img class="formulaInl" alt="$K_p$" src="form_6.png"/>, integrative <img class="formulaInl" alt="$K_i$" src="form_7.png"/> and derivative <img class="formulaInl" alt="$K_d$" src="form_8.png"/> gain constants;</li>
<li><b>PID controller with AF</b>, with settable proportional <img class="formulaInl" alt="$K_p$" src="form_6.png"/>, integrative <img class="formulaInl" alt="$K_i$" src="form_7.png"/>, derivative <img class="formulaInl" alt="$K_d$" src="form_8.png"/> and acceleration feedback <img class="formulaInl" alt="$af$" src="form_9.png"/> gain constants.</li>
</ul>
<p>For the sake of conciseness, we will show only PID controller without AF. </p><div class="fragment"><div class="line">properties (Access = <span class="keyword">public</span>)</div><div class="line">    <a class="code" href="_p_i_d___controller__prop_8m.html#aea16e677b2e2917cb9c325d8a924a519">kp</a>          % proportional gain</div><div class="line">    <a class="code" href="_p_i_d___controller__prop_8m.html#a16962c9a52053291f6e09374dc49af54">kd</a>          % derivative gain</div><div class="line">    <a class="code" href="_p_i_d___controller__prop_8m.html#a1fd5ef7057c3b988125c10fa4c9b613c">ki</a>          % integrative gain</div><div class="line">    <a class="code" href="_p_i_d___controller__prop_8m.html#a9a3c8ba3de0e3da9e4e895b3ec12f15a">integrative_error</a>        % integrative of error</div><div class="line">end</div></div><!-- fragment --><p> These properties are settable directly by the user, after the controller is constructed. </p><div class="fragment"><div class="line"><span class="keyword">function</span> [U,<a class="code" href="_i_controller__prop_8m.html#a35c88496fe3060ff4b9c67b1c5f1ff0f">tau</a>] = <a class="code" href="_i_controller__met_8m.html#a770267f2268b177addbd6030f3131175">process_</a>(obj, t, theta_m, dtheta_m, theta_e, dtheta_e, <a class="code" href="_i_controller__prop_8m.html#ae2b0415b572e4308dc810ad1306534af">ref</a>)</div><div class="line">    % necessary to retrieve the index</div><div class="line">    global simulation;</div><div class="line">    index = simulation.index;</div><div class="line">    params = simulation.params;</div><div class="line"></div><div class="line">    dref = 0;</div><div class="line">    <span class="keywordflow">if</span>(t-obj.prev_t ~= 0)</div><div class="line">        dref = (<a class="code" href="_i_controller__prop_8m.html#ae2b0415b572e4308dc810ad1306534af">ref</a> - obj.prev_ref) / (t - obj.prev_t);</div><div class="line">    end</div><div class="line"></div><div class="line">    % compute the three different errors</div><div class="line">    err = <a class="code" href="_i_controller__prop_8m.html#ae2b0415b572e4308dc810ad1306534af">ref</a> - tau_s;</div><div class="line">    derr = dref - dtau_s;</div><div class="line">    obj.integrative_error = obj.integrative_error + err;</div><div class="line"></div><div class="line">    % PID law</div><div class="line">    U = obj.kp * err + obj.kd * derr + obj.ki * obj.integrative_error;</div><div class="line"></div><div class="line">    % current saturation</div><div class="line">    <span class="keywordflow">if</span>(params.motor.current_saturation&gt;0 &amp;&amp; abs(U)&gt;params.motor.current_saturation)</div><div class="line">        U = sign(U) * params.motor.current_saturation;</div><div class="line">    end</div><div class="line">end</div></div><!-- fragment --><p> It's easy to notice the control law of this PID, that is: </p><p class="formulaDsp">
<img class="formulaDsp" alt="\[ U = K_p \: e + K_d \: \dot{e} + K_i \: \int e \: dt \]" src="form_10.png"/>
</p>
<p> where <img class="formulaInl" alt="$e = \tau_{ref} - \tau$" src="form_11.png"/> is the error.</p>
<h2><a class="anchor" id="simulation_steps"></a>
Simulation steps</h2>
<p>The main function is <a class="el" href="main_forecast_simulations_8m.html">mainForecastSimulations.m</a> and it's used to run all the simulations. It takes 3 parameters:</p><ul>
<li><b>simulation_dir</b>: directory to save the simulation output (and where there is the .yaml file)</li>
<li><b>simulation_name</b>: name of the simulation (and of the .yaml file)</li>
<li><b>configuration_name</b>: name of the configuration to use in the .yaml file</li>
</ul>
<p>First it creates all the necessary objects and loads all necessary parameters by calling <a class="el" href="configuration_8m.html" title="Configuration file. ">configuration.m</a>. Then, using a <em>try - catch</em> statement to handle possible simulation errors, it enters in a loop where it simulates the system within the different environments specified by the user. </p><div class="fragment"><div class="line"><span class="keywordflow">try</span></div><div class="line">    <span class="keywordflow">for</span> i = 1:params.tracking.environment.KES_NUM_ELEM</div><div class="line">        <span class="keywordflow">for</span> j= 1:params.tracking.environment.JES_NUM_ELEM</div><div class="line"></div><div class="line">            % update simulation params</div><div class="line">            params = simulation.params;</div><div class="line">            params.tracking.environment.index_ke = i;</div><div class="line">            params.tracking.environment.index_je = j;</div><div class="line"></div><div class="line">            % <span class="keyword">set</span> the <span class="keyword">new</span> parameters</div><div class="line">            simulation.setParams(params);</div><div class="line"></div><div class="line">            % create the reference signal</div><div class="line">            clear simulation_output</div><div class="line">            <a class="code" href="_i_controller__prop_8m.html#ae2b0415b572e4308dc810ad1306534af">ref</a> = [];</div><div class="line">            [<a class="code" href="_i_controller__prop_8m.html#ae2b0415b572e4308dc810ad1306534af">ref</a>,simulation_output.t] = <a class="code" href="reference__generator_8m.html#a40949c20e143fc75d8c1c5f48735930c">reference_generator</a>(params);</div><div class="line"></div><div class="line">            <span class="keywordflow">if</span>(max_duration &lt; max(simulation_output.t))</div><div class="line">                max_duration = max(simulation_output.t);</div><div class="line">            end</div><div class="line"></div><div class="line">            % run the simulation</div><div class="line">            simulation.run(ref,max(simulation_output.t));</div><div class="line"></div><div class="line">            % save the simulation output</div><div class="line">            simulation_output.ref = simulation.controller.ref;</div><div class="line">            simulation_output.tau = simulation.controller.tau;</div><div class="line">            simulation_output.err = simulation.controller.ref - simulation.controller.tau;</div><div class="line"></div><div class="line">            % transform the simulation output in matrix and table</div><div class="line">            clear simulation_output_matrix</div><div class="line">            simulation_output_matrix(:,1) = simulation_output.t<span class="stringliteral">&#39;;</span></div><div class="line"><span class="stringliteral">            simulation_output_matrix(:,2) = simulation_output.ref&#39;</span>;</div><div class="line">            simulation_output_matrix(:,3) = simulation_output.tau<span class="stringliteral">&#39;;</span></div><div class="line"><span class="stringliteral">            simulation_output_matrix(:,4) = simulation_output.err&#39;</span>;</div><div class="line">            simulation_output_table = array2table(simulation_output_matrix,<span class="stringliteral">&#39;VariableNames&#39;</span>,{<span class="charliteral">&#39;t&#39;</span>,<span class="stringliteral">&#39;ref&#39;</span>,<span class="stringliteral">&#39;tau&#39;</span>,<span class="stringliteral">&#39;err&#39;</span>});</div><div class="line"></div><div class="line">            % find and save the settling <a class="code" href="_i_controller__prop_8m.html#a9a5dcf2fcad7bf3ac86d488d1b924363">time</a> of the system</div><div class="line">            [step1,~,~,~] = <a class="code" href="split__signals_8m.html#a080cb05c7e3ed7b53c9caec33fc9687a">split_signals</a>(simulation_output_table,params);</div><div class="line">            t_settling = <a class="code" href="settling__time__index_8m.html#ad9db91639b8908a5f26f9f47c74e1292">settling_time_index</a>(step1,params,10);</div><div class="line"></div><div class="line">            % step analysis (includes bandwidth)</div><div class="line">            <a class="code" href="step__analysis__index_8m.html#a0a545f53c819acafca043655d9e1a722">step_analysis_index</a>(step1,params,10)</div><div class="line"></div><div class="line">            % save the simulation output table in a .csv file</div><div class="line">            csv_name = [simulation_dir simulation_name <span class="stringliteral">&#39;,ke=&#39;</span> num2str(params.ke) <span class="stringliteral">&#39;,je=&#39;</span> num2str(params.je) <span class="stringliteral">&#39;,tsettling=&#39;</span> num2str(t_settling) <span class="stringliteral">&#39;end.csv&#39;</span>];</div><div class="line">            writetable(simulation_output_table,csv_name);</div><div class="line">        end</div><div class="line">    end</div><div class="line"></div><div class="line">    % save the parameters in a .yaml file</div><div class="line">    params.writeToYamlFile(simulation_name,configuration_name);</div><div class="line"></div><div class="line"><span class="keywordflow">catch</span> e</div><div class="line">    <span class="keywordflow">if</span> isa(e,<span class="stringliteral">&#39;MSLException&#39;</span>)</div><div class="line">        <span class="stringliteral">&quot;ERROR: Simulation unstable. Change parameters and retry.&quot;</span> + e.message</div><div class="line">        e.getReport()</div><div class="line">    <span class="keywordflow">else</span></div><div class="line">        <span class="stringliteral">&quot;ERROR: &quot;</span> + e.message</div><div class="line">        e.getReport()</div><div class="line">    end</div><div class="line">end</div><div class="line"></div><div class="line">% run the <a class="code" href="_doxygen_matlab_2code__snippets_2_parameters_8m.html#a4801ead0cfada9df307f589e57c65cd8">transparency</a> simulation <span class="keywordflow">if</span> necessary</div><div class="line"><span class="keywordflow">if</span>(simulation.params.transparency.enable_transparency == <span class="keyword">true</span>)</div><div class="line">    mainTransparency;</div><div class="line">end</div><div class="line"></div><div class="line">% merge all .csv files in one</div><div class="line"><a class="code" href="_unique__csv_8m.html#af1e9002cccbaa057ed9637155f965260">Unique_csv</a>(simulation_dir, simulation_name, configuration_name);</div></div><!-- fragment --><p> Considering that each simulations can have multiple environments to test, for each environment we:</p><ul>
<li>Simulate the system;</li>
<li>Create a <em>.csv</em> file that contains in the name: <img class="formulaInl" alt="$Ke$" src="form_12.png"/>, <img class="formulaInl" alt="$Je$" src="form_13.png"/>, <img class="formulaInl" alt="$settling time$" src="form_14.png"/> and <img class="formulaInl" alt="$ts$" src="form_15.png"/>;</li>
<li>Fill the <em>.csv</em> file with the simulation output data: <img class="formulaInl" alt="$t$" src="form_16.png"/>, <img class="formulaInl" alt="$\tau_{ref}$" src="form_17.png"/>, <img class="formulaInl" alt="$\tau$" src="form_18.png"/> and <img class="formulaInl" alt="$err$" src="form_19.png"/>;</li>
</ul>
<p>If enabled, after the simulation of the system in all the environments under analysis, it does two more simulations for the transparency. <br />
 Every <em>.csv</em> file is temporarely saved in a directory specified by the user. At the end, all the <em>.csv</em> files generated are merged into one. This file is the final output of the simulation software and it is the input for the evaluation software.</p>
<h1><a class="anchor" id="performance_indicators_evaluation"></a>
Performance indicators evaluation</h1>
<p>This software is written in Matlab and computes the PIs, allowing the user to evaluate data from experiments (both real and virtual). The user sets the directory in which <em>.csv</em> file is stored for each experiment to evaluate.</p>
<h2><a class="anchor" id="files_composition"></a>
Files composition</h2>
<p>Files composition is the following, reminding that some files are shared with the simulation software:</p><ul>
<li><b><a class="el" href="main_forecast_p_i_8m.html">mainForecastPI.m</a></b>: main function to run to do the PIs evaluation</li>
<li><b>Utils/</b>: directory that contains some utility functions</li>
<li><b><a class="el" href="configuration_8m.html" title="Configuration file. ">configuration.m</a></b>: file that loads the parameters from the .yaml file</li>
<li><b>PerformanceIndicators/</b>: in this directory there are all the functions for the PIs<ul>
<li><b><a class="el" href="static__error__index_8m.html">static_error_index.m</a></b></li>
<li><b><a class="el" href="settling__time__index_8m.html">settling_time_index.m</a></b></li>
<li><b><a class="el" href="overshoot__index_8m.html">overshoot_index.m</a></b></li>
<li><b><a class="el" href="mean__error__index_8m.html">mean_error_index.m</a></b></li>
<li><b><a class="el" href="linearity__index_8m.html">linearity_index.m</a></b></li>
<li><b><a class="el" href="centroid__index_8m.html">centroid_index.m</a></b></li>
<li><b><a class="el" href="bandwidth__index_8m.html">bandwidth_index.m</a></b></li>
</ul>
</li>
</ul>
<h2><a class="anchor" id="evaluation_steps"></a>
Evaluation steps</h2>
<p>The main function is <a class="el" href="main_forecast_p_i_8m.html">mainForecastPI.m</a> and it's used to compute all the PIs. It takes 3 parameters:</p><ul>
<li><b>simulation_dir</b>: directory of the input files (<em>.csv</em> and <em>.yaml</em>)</li>
<li><b>simulation_name</b>: name of the .yaml file</li>
<li><b>configuration_name</b>: name of the configuration to use in the .yaml file</li>
</ul>
<p>First it creates all the necessary objects and loads all the necessary parameters by reading the <em>.yaml</em> file. <br />
 Then, for each experiment in the <em>.csv</em> file, it calls the functions for every PIs.</p>
<p>For each PI the outputs are:</p><ul>
<li><b>PI_name.png</b>: the plot of the result of the PI in a <em>.png</em> file</li>
<li><b>PI_name.yaml</b>: the result of the PI in a <em>.yaml</em> file</li>
</ul>
<p>where <em>PI_name</em> is the name of the PI. Output files are saved in <b>pi_output/</b>. </p>
</div></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
